LeetCode(235) Lowest Common Ancestor of a Binary Search Tree解题报告

来源:互联网 发布:拳皇98um中文版优化 编辑:程序博客网 时间:2024/06/03 13:31

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

        ____6______       /           \    ___2__       ___8__   /      \     /      \   0      _4   7        9         /  \         3   5

For example, the lowest common ancestor (LCA) of nodes 2 and 8 is 6. Another example is LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

解题思路:

因为是BST,所以很好判断,如果root比p,q任何一个都小,那么LCA一定在右子树上,递归,反之,在左子树,如果正好比一个大,比一个小,那么LCA就是root

下面分别附上递归和迭代解法:

public class Solution {    public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {        if(root.val < Math.min(p.val, q.val))            return lowestCommonAncestor(root.right,p,q);        if(root.val > Math.max(p.val, q.val))            return lowestCommonAncestor(root.left,p,q);        return root;    }}
public class Solution {    public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {        while(true){            while(root.val < Math.min(p.val,q.val)){                root = root.right;            }            while(root.val > Math.max(p.val,q.val)){                root = root.left;            }            while(root.val <= Math.max(p.val, q.val) && root.val >= Math.min(p.val,q.val))                return root;        }    }}
0 0